mkrootfs.sh.in 8.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267
  1. #!/bin/sh
  2. #-
  3. # Copyright (c) 2013-2015 Juan Romero Pardines.
  4. # All rights reserved.
  5. #
  6. # Redistribution and use in source and binary forms, with or without
  7. # modification, are permitted provided that the following conditions
  8. # are met:
  9. # 1. Redistributions of source code must retain the above copyright
  10. # notice, this list of conditions and the following disclaimer.
  11. # 2. Redistributions in binary form must reproduce the above copyright
  12. # notice, this list of conditions and the following disclaimer in the
  13. # documentation and/or other materials provided with the distribution.
  14. #
  15. # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  16. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  17. # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  18. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
  19. # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  20. # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  21. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  22. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  23. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  24. # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  25. #-
  26. readonly PROGNAME=$(basename $0)
  27. readonly ARCH=$(uname -m)
  28. trap 'die "Interrupted! exiting..."' INT TERM HUP
  29. info_msg() {
  30. printf "\033[1m$@\n\033[m"
  31. }
  32. die() {
  33. echo "FATAL: $@"
  34. umount_pseudofs
  35. [ -d "$rootfs" ] && rm -rf $rootfs
  36. exit 1
  37. }
  38. usage() {
  39. cat <<_EOF
  40. Usage: $PROGNAME [options] <platform>
  41. Supported platforms: i686, i686-musl, x86_64, x86_64-musl,
  42. dockstar, bananapi, beaglebone, cubieboard2, cubietruck,
  43. odroid-u2, rpi, rpi2 (armv7), usbarmory, ci20
  44. Options
  45. -b <syspkg> Set an alternative base-system package (defaults to base-system)
  46. -c <dir> Set XBPS cache directory (defaults to \$PWD/xbps-cachedir-<arch>)
  47. -C <file> Full path to the XBPS configuration file
  48. -h Show this help
  49. -p <pkgs> Additional packages to install into the rootfs (separated by blanks)
  50. -r <repo> Set XBPS repository (may be set multiple times)
  51. -k <cmd> Call "cmd <ROOTFSPATH>" after building the rootfs
  52. -V Show version
  53. _EOF
  54. }
  55. mount_pseudofs() {
  56. for f in dev proc sys; do
  57. [ ! -d $rootfs/$f ] && mkdir -p $rootfs/$f
  58. mount -r --bind /$f $rootfs/$f
  59. done
  60. }
  61. umount_pseudofs() {
  62. for f in dev proc sys; do
  63. umount -f $rootfs/$f >/dev/null 2>&1
  64. done
  65. }
  66. run_cmd_target() {
  67. info_msg "Running $@ for target $_ARCH ..."
  68. case "${_TARGET_ARCH}" in
  69. i686*|x86_64*) eval XBPS_ARCH=${_TARGET_ARCH} "$@";;
  70. *) eval XBPS_TARGET_ARCH=${_TARGET_ARCH:=${_ARCH}} "$@";;
  71. esac
  72. [ $? -ne 0 ] && die "Failed to run $@"
  73. }
  74. run_cmd() {
  75. info_msg "Running $@ ..."
  76. eval "$@"
  77. [ $? -ne 0 ] && die "Failed to run $@"
  78. }
  79. register_binfmt() {
  80. if [ "$ARCH" = "${_ARCH}" ]; then
  81. return 0
  82. fi
  83. mountpoint -q /proc/sys/fs/binfmt_misc || modprobe -q binfmt_misc; mount -t binfmt_misc binfmt_misc /proc/sys/fs/binfmt_misc
  84. case "${_ARCH}" in
  85. armv*)
  86. echo ':arm:M::\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28\x00:\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff:/usr/bin/qemu-arm-static:' > /proc/sys/fs/binfmt_misc/register
  87. ;;
  88. mipsel*)
  89. echo ':mipsel:M::\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00:\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff:/usr/bin/qemu-mipsel-static:' > /proc/sys/fs/binfmt_misc/register
  90. ;;
  91. *)
  92. die "Unknown target architecture!"
  93. ;;
  94. esac
  95. cp -f $(which $QEMU_BIN) $rootfs/usr/bin || die "failed to copy $QEMU_BIN to the rootfs"
  96. }
  97. #
  98. # main()
  99. #
  100. while getopts "b:C:c:hp:r:k:V" opt; do
  101. case $opt in
  102. b) PKGBASE="$OPTARG";;
  103. C) XBPS_CONFFILE="-C $OPTARG";;
  104. c) XBPS_CACHEDIR="--cachedir=$OPTARG";;
  105. h) usage; exit 0;;
  106. p) EXTRA_PKGS="$OPTARG";;
  107. r) XBPS_REPOSITORY="$XBPS_REPOSITORY --repository=$OPTARG";;
  108. k) POST_HOOK="$OPTARG";;
  109. V) echo "$PROGNAME @@MKLIVE_VERSION@@"; exit 0;;
  110. esac
  111. done
  112. shift $(($OPTIND - 1))
  113. PLATFORM="$1"
  114. SUBPLATFORM=$PLATFORM
  115. case "$PLATFORM" in
  116. i686*) _TARGET_ARCH="$PLATFORM"; _ARCH="i686";;
  117. x86_64*) _TARGET_ARCH="$PLATFORM"; _ARCH="x86_64";;
  118. dockstar) _TARGET_ARCH="armv5tel"; _ARCH="armv5tel";;
  119. rpi-musl) _TARGET_ARCH="armv6l-musl"; _ARCH="armv6l";;
  120. rpi) _TARGET_ARCH="armv6l"; _ARCH="armv6l";;
  121. ci20-musl) _TARGET_ARCH="mipselhf-musl"; _ARCH="mipsel-musl";;
  122. ci20) _TARGET_ARCH="mipselhf"; _ARCH="mipsel";;
  123. *-musl) _TARGET_ARCH="armv7l-musl"; _ARCH="armv7l";;
  124. *) _TARGET_ARCH="armv7l"; _ARCH="armv7l";;
  125. esac
  126. : ${XBPS_REPOSITORY:=--repository=http://repo.voidlinux.eu/current --repository=http://muslrepo.voidlinux.eu/current}
  127. : ${XBPS_CACHEDIR:=--cachedir=$PWD/xbps-cachedir-${_TARGET_ARCH}}
  128. case "$PLATFORM" in
  129. i686*|x86_64*) PKGBASE="base-voidstrap";;
  130. *) PKGBASE="base-system";;
  131. esac
  132. if [ -z "$PLATFORM" ]; then
  133. echo "$PROGNAME: platform was not set!"
  134. usage; exit 1
  135. fi
  136. case "$PLATFORM" in
  137. bananapi*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  138. beaglebone*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  139. cubieboard2*|cubietruck*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  140. dockstar*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  141. odroid-u2*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  142. rpi2*) SUBPLATFORM=rpi; QEMU_BIN=qemu-arm-static;;
  143. rpi*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  144. usbarmory*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  145. ci20*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-mipsel-static;;
  146. i686*) QEMU_BIN=qemu-i386-static;;
  147. x86_64*) QEMU_BIN=qemu-x86_64-static;;
  148. *) die "$PROGNAME: invalid platform!";;
  149. esac
  150. if [ "$(id -u)" -ne 0 ]; then
  151. die "need root perms to continue, exiting."
  152. fi
  153. #
  154. # Check for required binaries.
  155. #
  156. for f in chroot tar xbps-install xbps-reconfigure xbps-query; do
  157. if ! $f --version >/dev/null 2>&1; then
  158. die "$f binary is missing in your system, exiting."
  159. fi
  160. done
  161. if ! $QEMU_BIN -version >/dev/null 2>&1; then
  162. die "$QEMU_BIN binary is missing in your system, exiting."
  163. fi
  164. #
  165. # Check if package base-system is available.
  166. #
  167. rootfs=$(mktemp -d || die "FATAL: failed to create tempdir, exiting...")
  168. mkdir -p $rootfs/var/db/xbps/keys
  169. cp keys/*.plist $rootfs/var/db/xbps/keys
  170. run_cmd_target "xbps-install -S $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -r $rootfs"
  171. run_cmd_target "xbps-query -R -r $rootfs $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -ppkgver $PKGBASE"
  172. chmod 755 $rootfs
  173. case "$PLATFORM" in
  174. i686*|x86_64*) PKGS="${PKGBASE}" ;;
  175. *) PKGS="${PKGBASE} ${SUBPLATFORM}-base" ;;
  176. esac
  177. [ -n "$EXTRA_PKGS" ] && PKGS="${PKGS} ${EXTRA_PKGS}"
  178. mount_pseudofs
  179. #
  180. # Install base-system to the rootfs directory.
  181. #
  182. run_cmd_target "xbps-install -S $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -r $rootfs -y ${PKGS}"
  183. # Enable en_US.UTF-8 locale and generate it into the target rootfs.
  184. if [ -e $rootfs/etc/default/libc-locales ]; then
  185. LOCALE=en_US.UTF-8
  186. sed -e "s/\#\(${LOCALE}.*\)/\1/g" -i $rootfs/etc/default/libc-locales
  187. fi
  188. #
  189. # Reconfigure packages for target architecture: must be reconfigured
  190. # thru the qemu user mode binary.
  191. #
  192. if [ -n "${_ARCH}" ]; then
  193. info_msg "Reconfiguring packages for ${_ARCH} ..."
  194. case "$PLATFORM" in
  195. i686*|x86_64*)
  196. run_cmd "XBPS_ARCH=${PLATFORM} xbps-reconfigure -r $rootfs base-files"
  197. ;;
  198. *)
  199. register_binfmt
  200. run_cmd "xbps-reconfigure -r $rootfs base-files"
  201. run_cmd "chroot $rootfs env -i xbps-reconfigure -f base-files"
  202. rmdir $rootfs/usr/lib32 2>/dev/null
  203. rm -f $rootfs/lib32 $rootfs/lib64 $rootfs/usr/lib64
  204. ;;
  205. esac
  206. run_cmd "chroot $rootfs xbps-reconfigure -a"
  207. fi
  208. #
  209. # Setup default root password.
  210. #
  211. run_cmd "chroot $rootfs sh -c 'echo "root:voidlinux" | chpasswd -c SHA512'"
  212. if [ -n "$POST_HOOK" ]; then
  213. run_cmd "$POST_HOOK $rootfs"
  214. fi
  215. umount_pseudofs
  216. #
  217. # Cleanup rootfs.
  218. #
  219. rm -f $rootfs/etc/.pwd.lock 2>/dev/null
  220. rm -rf $rootfs/var/cache/* 2>/dev/null
  221. #
  222. # Generate final tarball.
  223. #
  224. arch=$ARCH
  225. if [ -n "${_ARCH}" ]; then
  226. rm -f $rootfs/usr/bin/$QEMU_BIN
  227. arch=${_ARCH}
  228. fi
  229. tarball=void-${PLATFORM}-rootfs-$(date '+%Y%m%d').tar.xz
  230. run_cmd "tar -cp --posix -C $rootfs . | xz -T0 -9 > $tarball "
  231. rm -rf $rootfs
  232. info_msg "Successfully created $tarball ($PLATFORM)"
  233. # vim: set ts=4 sw=4 et: